edelib: TiXmlBase Class Reference

edelib 1.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Static Protected Member Functions | Protected Attributes | Static Protected Attributes | Friends | List of all members
TiXmlBase Class Referenceabstract

Xml base class. More...

`#include <edelib/TiXml.h>`

Inheritance diagram for TiXmlBase:

## Public Types
enum | { TIXML_NO_ERROR = 0, TIXML_ERROR, TIXML_ERROR_OPENING_FILE, TIXML_ERROR_OUT_OF_MEMORY, TIXML_ERROR_PARSING_ELEMENT, TIXML_ERROR_FAILED_TO_READ_ELEMENT_NAME, TIXML_ERROR_READING_ELEMENT_VALUE, TIXML_ERROR_READING_ATTRIBUTES, TIXML_ERROR_PARSING_EMPTY, TIXML_ERROR_READING_END_TAG, TIXML_ERROR_PARSING_UNKNOWN, TIXML_ERROR_PARSING_COMMENT, TIXML_ERROR_PARSING_DECLARATION, TIXML_ERROR_DOCUMENT_EMPTY, TIXML_ERROR_EMBEDDED_NULL, TIXML_ERROR_PARSING_CDATA, TIXML_ERROR_DOCUMENT_TOP_ONLY, TIXML_ERROR_STRING_COUNT }

## Public Member Functions
virtual void | Print (FILE *cfile, int depth) const =0
int | Row () const
int | Column () const
void | SetUserData (void *user)
void * | GetUserData ()
const void * | GetUserData () const

## Static Public Member Functions
static void | SetCondenseWhiteSpace (bool condense)
static bool | IsWhiteSpaceCondensed ()

## Static Protected Member Functions
static const char * | ReadName (const char *p, edelib::String *name, TiXmlEncoding encoding)
static const char * | ReadText (const char *in, edelib::String *text, bool ignoreWhiteSpace, const char *endTag, bool ignoreCase, TiXmlEncoding encoding)
static const char * | GetEntity (const char *in, char *value, int *length, TiXmlEncoding encoding)
static const char * | GetChar (const char *p, char *_value, int *length, TiXmlEncoding encoding)
static void | PutString (const edelib::String &str, edelib::String *out)
static bool | StringEqual (const char *p, const char *endTag, bool ignoreCase, TiXmlEncoding encoding)
static int | IsAlpha (unsigned char anyByte, TiXmlEncoding encoding)
static int | IsAlphaNum (unsigned char anyByte, TiXmlEncoding encoding)
static int | ToLower (int v, TiXmlEncoding encoding)
static void | ConvertUTF32ToUTF8 (unsigned long input, char *output, int *length)

## Protected Attributes
TiXmlCursor | location
void * | userData

## Static Protected Attributes
static const char * | errorString [TIXML_ERROR_STRING_COUNT]

## Friends
class | TiXmlNode
class | TiXmlElement
class | TiXmlDocument

## Detailed Description

Xml base class.

TiXmlBase is a base class for every class in TinyXml. It does little except to establish that TinyXml classes can be printed and provide some utility functions.

In XML, the document and elements can contain other elements and other types of nodes.

    *   A Document can contain:
    *     Element (container or leaf)
    *     Comment (leaf)
    *     Unknown (leaf)
    *     Declaration( leaf )
    *
    *   An Element can contain:
    *     Element (container or leaf)
    *      Text (leaf)
    *      Attributes (not on tree)
    *      Comment (leaf)
    *      Unknown (leaf)
    *
    *   A Decleration contains:
    *      Attributes (not on tree)
    *

## Member Function Documentation

int Column | ( |  | ) | const
| inline

See Row()

References location.

static void ConvertUTF32ToUTF8 | ( | unsigned long | input,
|  | char * | output,
|  | int * | length
| ) |  |
| staticprotected

Convert from UTF-32 to UTF-8

Referenced by ToLower().

static const char* GetChar | ( | const char * | p,
|  | char * | _value,
|  | int * | length,
|  | TiXmlEncoding | encoding
| ) |  |
| inlinestaticprotected

Get a character, while interpreting entities. The length can be from 0 to 4 bytes.

References GetEntity(), PutString(), and StringEqual().

static const char* GetEntity | ( | const char * | in,
|  | char * | value,
|  | int * | length,
|  | TiXmlEncoding | encoding
| ) |  |
| staticprotected

If an entity has been found, transform it into a character

Referenced by GetChar(), and GetUserData().

void* GetUserData | ( |  | ) |
| inline

Get a pointer to arbitrary user data.

References userData.

const void* GetUserData | ( |  | ) | const
| inline

Get a pointer to arbitrary user data.

References GetEntity(), TiXmlDocument::Parse(), ReadName(), ReadText(), and userData.

static int IsAlpha | ( | unsigned char | anyByte,
|  | TiXmlEncoding | encoding
| ) |  |
| staticprotected

None of these methods are reliable for any language except English. Good for approximation, not great for accuracy.

static int IsAlphaNum | ( | unsigned char | anyByte,
|  | TiXmlEncoding | encoding
| ) |  |
| staticprotected

See IsAlpha()

static bool IsWhiteSpaceCondensed | ( |  | ) |
| inlinestatic

Return the current white space setting

virtual void Print | ( | FILE * | cfile,
|  | int | depth
| ) |  | const
| pure virtual

All TinyXml classes can print themselves to a filestream or the string class (TiXmlString in non-STL mode, std::string in STL mode.) Either or both cfile and str can be null.

This is a formatted print, and will insert t abs and newlines.

(For an unformatted stream, use the << operator.)

Implemented in TiXmlDocument, TiXmlUnknown, TiXmlDeclaration, TiXmlText, TiXmlComment, TiXmlElement, and TiXmlAttribute.

static void PutString | ( | const edelib::String & | str,
|  | edelib::String * | out
| ) |  |
| staticprotected

Puts a string to a stream, expanding entities as it goes. Note this should not contian the '<', '>', etc, or they will be transformed into entities!

Referenced by GetChar().

static const char* ReadName | ( | const char * | p,
|  | edelib::String * | name,
|  | TiXmlEncoding | encoding
| ) |  |
| staticprotected

Reads an XML name into the string provided. Returns a pointer just past the last character of the name, or 0 if the function has an error.

Referenced by GetUserData().

static const char* ReadText | ( | const char * | in,
|  | edelib::String * | text,
|  | bool | ignoreWhiteSpace,
|  | const char * | endTag,
|  | bool | ignoreCase,
|  | TiXmlEncoding | encoding
| ) |  |
| staticprotected

Reads text. Returns a pointer past the given end tag. Wickedly complex options, but it keeps the (sensitive) code in one place.

Referenced by GetUserData().

int Row | ( |  | ) | const
| inline

Return the position, in the original source file, of this node or attribute. The row and column are 1-based. (That is the first row and first column is 1,1). If the returns values are 0 or less, then the parser does not have a row and column value.

Generally, the row and column value will be set when the TiXmlDocument::Load(), TiXmlDocument::LoadFile(), or any TiXmlNode::Parse() is called. It will NOT be set when the DOM was created from operator>>. The values reflect the initial load. Once the DOM is modified programmatically (by adding or changing nodes and attributes) the new values will NOT update to reflect changes in the document.

There is a minor performance cost to computing the row and column. Computation can be disabled if TiXmlDocument::SetTabSize() is called with 0 as the value.

See also
  TiXmlDocument::SetTabSize()

References location.

static void SetCondenseWhiteSpace | ( | bool | condense | ) |
| inlinestatic

The world does not agree on whether white space should be kept or not. In order to make everyone happy, these global, static functions are provided to set whether or not TinyXml will condense all white space into a single space or not. The default is to condense. Note changing this value is not thread safe.

void SetUserData | ( | void * | user | ) |
| inline

Set a pointer to arbitrary user data.

References userData.

static bool StringEqual | ( | const char * | p,
|  | const char * | endTag,
|  | bool | ignoreCase,
|  | TiXmlEncoding | encoding
| ) |  |
| staticprotected

Return true if the next characters in the stream are any of the endTag sequences. Ignore case only works for english, and should only be relied on when comparing to English words: StringEqual( p, "version", true ) is fine.

Referenced by GetChar().

static int ToLower | ( | int | v,
|  | TiXmlEncoding | encoding
| ) |  |
| inlinestaticprotected

See IsAlpha()

References ConvertUTF32ToUTF8(), and TiXmlDocument::operator=().

## Member Data Documentation

const char* errorString[TIXML_ERROR_STRING_COUNT]
| staticprotected

List of error strings

TiXmlCursor location
| protected

Current location in parsing

Referenced by Column(), and Row().

void* userData
| protected

Field containing a generic user pointer

Referenced by GetUserData(), and SetUserData().

The documentation for this class was generated from the following file:

- edelib/TiXml.h